/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bdd;

import com.test.beans.Pompier;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpSession;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import util.MD5;

/**
 *
 * @author clementine.desrucques
 */
public class PompierMySql {

    private Connection theConnection;
    private Pompier unPompier;

    /**
     * Constructeur
     */
    public PompierMySql() {
        theConnection = Connexion.getConnect("localhost", //s erveur
                "sdis29", // base de données
                "admin",// user
                "minda"); // mot de passe ClientMysql() {
    }

    /**
     * Recherche de tous les clients
     *
     * @return collection de clients
     */
    public ArrayList<Pompier> readAll() {
        ArrayList<Pompier> lesPompiers = new ArrayList<>();

        try {
            Statement stmt = theConnection.createStatement();
            ResultSet resultQ = null;
            resultQ = stmt.executeQuery("SELECT * FROM pompier");
            while (resultQ.next()) {
                unPompier = new  Pompier (resultQ.getInt("id"),
                        resultQ.getInt("idCaserne"),
                        resultQ.getString("nom"),
                        resultQ.getString("prenom"),
                        resultQ.getInt("statut"),
                        resultQ.getInt("typePers"),
                        resultQ.getString("mail"),
                        resultQ.getString("login"),
                        resultQ.getString("mdp"),
                        resultQ.getString("adresse"),
                        resultQ.getString("cp"),
                        resultQ.getString("ville"),
                        resultQ.getString("bip"),
                        resultQ.getInt("nbGardes"),
                        resultQ.getInt("grade"),
                        resultQ.getString("commentaire")
                        resultQ.getInt("idEmployeur")
                                );
                lesPompiers.add(unPompier);
            }
            resultQ.close();
            stmt.close();
            //theConnection.close();
        } catch (SQLException ex) {
            System.out.println("SQLException : " + ex.getMessage());
            System.out.println("SQLState : " + ex.getSQLState());
            System.out.println("Code erreur : " + ex.getErrorCode());
        }

        return lesPompiers;
    }


    /**
     * Creation du pompier passé en paramètre dans la table pompier Requête
     * préparée
     *
     * @param p objet de type Pompier (sans identifiant)
     * @return int : id du pompier créé
     */
    public int createRP(Pompier p) {
        int id = -1;
        try {
            PreparedStatement stmt = null;
            String sql = "INSERT INTO pompier(idCaserne, nom, prenom, statut, typePers, mail, login, mdp, adresse, cp, ville, bip, nbGardes, grade, commentaire, idEmployeur) "
                    + "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?);";
            stmt = theConnection.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS);
            stmt.setInt(1, p.getIdCaserne());
            stmt.setString(2, p.getNom());
            stmt.setString(3, p.getPrenom());
            stmt.setInt(4, p.getStatut());
            stmt.setString(5, p.getMail());
            stmt.setString(6, p.getLogin());
            stmt.setString(7, p.getMdp());
            stmt.setInt(8, p.getAdrNo());
            stmt.setString(9, p.getAdrRue());
            stmt.setString(10, p.getAdrCP());
            stmt.setString(11, p.getAdrVille());
            stmt.setInt(12, p.getGrade());

            System.out.println("Requête : " + stmt.toString());
            int status = stmt.executeUpdate();

            // Recherche de l'identifiant du client créé            
            if (status > 0) {
                ResultSet result = stmt.getGeneratedKeys();
                if (result.first()) {
                    id = result.getInt(1);
                }
            }
        } catch (SQLException ex) {
            System.out.println("SQLException : " + ex.getMessage());
            System.out.println("SQLState : " + ex.getSQLState());
            System.out.println("Code erreur : " + ex.getErrorCode());
        }
        return id;
    }

    public boolean isAuthentified(HttpServletRequest request) {

        boolean resultat = false;
        String login = request.getParameter("ztPseudo");
        String mdp = request.getParameter("ztMDP");
        String mdpChiffre = MD5.encode(request.getParameter("ztMDP"));
        String sql = "SELECT * FROM pompier WHERE login='" + login + "' AND mdp='" + mdpChiffre + "' AND typePers='1';";
        System.out.println("sql:" + sql);
        try {
            Statement stmt = theConnection.createStatement();
            ResultSet resultQ = null;
            resultQ = stmt.executeQuery(sql);
            resultat = (resultQ.next());
            if (resultat) {
                Pompier lePompier = new Pompier(
                        resultQ.getInt("id"),
                        resultQ.getInt("idCaserne"),
                        resultQ.getString("nom"),
                        resultQ.getString("prenom"),
                        resultQ.getInt("statut"),
                        resultQ.getInt("typePers"),
                        resultQ.getString("mail"),
                        resultQ.getString("login"),
                        resultQ.getString("mdp"),
                        resultQ.getString("adresse"),
                        resultQ.getString("cp"),
                        resultQ.getString("ville"),
                        resultQ.getString("bip"),
                        resultQ.getInt("nbGardes"),
                        resultQ.getInt("grade"),
                        resultQ.getString("commentaire"),
                        resultQ.getInt("idEmployeur"),
                        
                );
                
                
                HttpSession maSession = request.getSession();
                maSession.setAttribute("unPompier", lePompier);
                System.out.println("lePompier :"+ lePompier);
            }

        } catch (SQLException ex) {
            Logger.getLogger(PompierMySql.class.getName()).log(Level.SEVERE, null, ex);
        }
        return resultat;
    }

    private void setResultat(String pompier) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

}
